package bank.app.account;

import bank.Account;
import bank.app.exceptions.InvalidDepositUIException;
import bank.app.exceptions.NegativeDepositUIException;
import bank.exceptions.InvalidDepositException;
import bank.exceptions.NegativeAmountException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Command for making deposits.
 */
public class DoDeposit extends Command<Account> {

  /** @param receiver */
  public DoDeposit(Account receiver) {
    super(Labels.DEPOSIT, receiver);
    addRealField("amount", Prompts.requestAmount());
  }

  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      _receiver.deposit(realField("amount"));
    } catch (InvalidDepositException e) {
      throw new InvalidDepositUIException(e.getAccount(), e.getAmount());
    } catch (NegativeAmountException e) {
      throw new NegativeDepositUIException(e.getAmount());
    }
  }
}
