package bank.app.account;

import bank.Account;
import bank.accounts.Savings;
import bank.app.exceptions.InvalidSavingsAccountIdException;
import bank.app.savings.Menu;
import bank.exceptions.NoSuchSavingsAccountException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Open menu for a specific savings account.
 */
public class DoOpenMenuSavingsAccount extends Command<Account> {

  /** @param receiver */
  public DoOpenMenuSavingsAccount(Account receiver) {
    super(Labels.OPEN_MENU_SAVINGS_ACCOUNT, receiver);
    addIntegerField("id", Prompts.requestSavingsAccountId());
  }

  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      Savings account = _receiver.savingsAccount(integerField("id"));
      Menu m = new Menu(account);
      m.open();
    } catch (NoSuchSavingsAccountException e) {
      throw new InvalidSavingsAccountIdException(e.getId());
    }

  }
}
