package bank.app.account;

import bank.Account;
import bank.Bank;
import bank.app.exceptions.InvalidRemovalUIException;
import bank.exceptions.InvalidRemovalException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Remove a this account from the bank. The menu closes.
 */
public class DoRemoveAccount extends Command<Account> {

  /** The bank the account belongs to. */
  private Bank _bank;

  /**
   * @param receiver the target account.
   * @param bank     the bank the account belongs to.
   */
  public DoRemoveAccount(Account receiver, Bank bank) {
    super(true, Labels.REMOVE_ACCOUNT, receiver);
    _bank = bank;
  }

  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      _bank.removeAccount(_receiver);
    } catch (InvalidRemovalException e) {
      throw new InvalidRemovalUIException(e.getAccount(), e.getAmount());
    }
  }
}
