package bank.app.bank;

import bank.Account;
import bank.Bank;
import bank.app.account.Menu;
import bank.app.exceptions.InvalidAccountIdException;
import bank.exceptions.NoSuchAccountException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Open account menu.
 */
public class DoOpenMenuAccount extends Command<Bank> {

  /** @param receiver */
  public DoOpenMenuAccount(Bank receiver) {
    super(Labels.OPEN_MENU_ACCOUNT, receiver);
    addIntegerField("id", Prompts.requestAccountId());
  }

  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      Account account = _receiver.account(integerField("id"));
      Menu menu = new Menu(account, _receiver);
      menu.open();
    } catch (NoSuchAccountException e) {
      throw new InvalidAccountIdException(e.getId());
    }
  }
  
}
