package bank.app.bank;

import bank.Bank;
import bank.Client;
import bank.app.client.Menu;
import bank.app.exceptions.InvalidClientIdException;
import bank.exceptions.NoSuchClientException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Open client menu.
 */
public class DoOpenMenuClient extends Command<Bank> {

  /** @param receiver */
  public DoOpenMenuClient(Bank receiver) {
    super(Labels.OPEN_MENU_CLIENT, receiver);
    addIntegerField("id", Prompts.requestClientId());
  }
  
  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      Client client = _receiver.client(integerField("id"));
      Menu menu = new Menu(client);
      menu.open();
    } catch (NoSuchClientException e) {
      throw new InvalidClientIdException(e.getId());
    }
  }
  
}
