package bank.app.bank;

import bank.Bank;
import bank.app.exceptions.DuplicateClientIdException;
import bank.exceptions.DuplicateClientException;
import pt.tecnico.uilib.menus.Command;
import pt.tecnico.uilib.menus.CommandException;

/**
 * Register a new client (account holder).
 */
public class DoRegisterClient extends Command<Bank> {

  /** @param receiver */
  public DoRegisterClient(Bank receiver) {
    super(Labels.REGISTER_CLIENT, receiver);
    addIntegerField("id", Prompts.requestClientId());
    addStringField("name", Prompts.requestHolderName());
  }

  /** @see pt.tecnico.po.ui.Command#execute() */
  @Override
  protected final void execute() throws CommandException {
    try {
      int id = integerField("id");
      String name = stringField("name");
      _receiver.registerClient(id, name);
      _display.popup(Messages.clientCreated(id, name));
    } catch (DuplicateClientException e) {
      throw new DuplicateClientIdException(e.getId());
    }
  }
}
